<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>Form task 2</title>
  <script>
    /*
      Задание:
        Сделать шиблонизатор элемента по:
        Ширине input type=range
        Цвету  input type=color
        Высоте input type=range
        Скругление углов input type=range
        Padding input type=range

      Свойсвта: https://developer.mozilla.org/en-US/docs/Web/CSS/CSS_Properties_Reference

        + Сделать выборку цвета из рандомных 20 цветов которые выбираются из появившегося блока :
        https://s3.envato.com/files/230412754/screenshots/1.png
        За заготовку для рандома цвета использовать функцию из первых занятий.

    */

    window.addEventListener("load", function () {
      let myWidth = document.getElementById('myWidth');
      let myColor = document.getElementById('myColor');
      let myHeight = document.getElementById('myHeight');
      let myRadius = document.getElementById('myRadius');
      let myPadding = document.getElementById('myPadding');

      myWidth.addEventListener('input', function(event){
        result.style.width = event.target.value + 'px';
      });
      myHeight.addEventListener('input', function(event){
        result.style.height = event.target.value + 'px';
      });
      myRadius.addEventListener('input', function(event){
        result.style.borderRadius = event.target.value / 2 + 'px';
      });
      myPadding.addEventListener('input', function(event){
        result.style.width = event.target.value + 'px';
      });
      myColor.addEventListener('click', colorHandler);
      myColor.addEventListener('input', function(event){
        result.style.background = event.target.value;
      });
    });

    function colorHandler(e) {
      e.preventDefault();

      let colors = document.getElementById('colors');
      colors.innerHTML = null;
      colors.style.visibility = 'visible';
      for (let i=0; i < 20; i++) {
        let circle = document.createElement('div');
        circle.className = 'circle';
        let colorValue = getColor();
        circle.style.background = colorValue;
        colors.appendChild(circle);

        circle.addEventListener('click', function (e) {
          result.style.background = colorValue;
          document.getElementById('myColor').value = colorValue;
          colors.style.visibility = 'hidden';
        });
      }
    }

    function getColor() {
      let color = '#';
      for (let i=0; i<3; i++) {
        let rand = getRandomIntInclusive(0, 255);
        color += rand.toString(16);
      }
      return color;
    }

    function getRandomIntInclusive(min, max) {
      min = Math.ceil(min);
      max = Math.floor(max);
      return Math.floor(Math.random() * (max - min + 1)) + min;
    }

  </script>
</head>
<body>
  <div class="Templating">
    <form>
      <input type="range" id="myWidth" min="10" max="500" step="10"/>
      <input type="color" id="myColor" min="10" max="500" step="10"/>
      <input type="range" id="myHeight" min="10" max="500" step="10"/>
      <input type="range" id="myRadius" min="10" max="500" step="10"/>
      <input type="range" id="myPadding" min="10" max="500" step="10"/>
    </form>

    <div class="TemplatingResult">
      <div id="result" class="result"></div>
    </div>

    <div id="colors"></div>
  </div>

  <style>
    #colors{
      width: 200px;

      display: flex;
      flex-wrap: wrap;
    }
    .result{
      width: 50px;
      background: gray;
      box-sizing: border-box;
      padding: 10px;
    }
    #MyValidateForm{
      width: 350px;
      display: flex;
      flex-direction: column;
    }
    #MyValidateForm input{
      margin-bottom: 10px;
      box-sizing: border-box;
      padding: 10px 20px;
    }
    .circle{
      width: 40px;
      height: 40px;
      background: #eee;
      border-radius: 50%;
    }
  </style>
</body>
</html>
